(*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *)
(*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *)

(* let show_token lexbuf pos =  *)
(*   let s=Lexing.lexeme_start lexbuf *)
(*   and e=Lexing.lexeme_end lexbuf *)
(*   in Printf.printf "%s" ((String.make (s - pos) ' ') ^ (String.make (e-s) '^'))  *)

let rec get_ast lexbuf = 
  try 
    Parser.start Lexer.token lexbuf
  with 
    | Failure s -> Printf.printf "Erreur: %s\nEssaye encore...\n" s ;
	flush stdout;
	get_ast lexbuf
    | Parsing.Parse_error -> Printf.printf "Erreur de parsing : essaye encore...\n" ; 
	flush stdout;
	get_ast lexbuf
    | Lexer.Lexerror -> Printf.printf "Tu as cris un mot que je ne comprends pas.\n" ;
	flush stdout;
	get_ast lexbuf
    | _ -> Printf.printf "Erreur inconnue.\n" ; 
	exit 1
;;
